#include "StdAfx.h"
#include "Capusb_Main.h"
#include "resource.h"

#define INI_MAX_LEN	MAX_PATH*2

// f[^
static void IniIO_String(BOOL bSaveFlg,char *lpszFile,char *lpszKey,char *lpszSubKey,char *lpBuf,DWORD nBufSize,char *lpszDefault)
{
	if(bSaveFlg)
	{
		WritePrivateProfileString(lpszKey,lpszSubKey,lpBuf,lpszFile);
	} else {		
		GetPrivateProfileString(lpszKey,lpszSubKey,lpszDefault,lpBuf,nBufSize,lpszFile);
	}
}

// lf[^(signed 32bit)
void IniIO_INT(BOOL bSaveFlg,char *lpszFile,char *lpszKey,char *lpszSubKey,int& iData,int iDefault)
{
	char tmp[INI_MAX_LEN];
	if( bSaveFlg )
	{		
		wsprintf(tmp,"%d",iData);
		WritePrivateProfileString(lpszKey,lpszSubKey,tmp,lpszFile);
	} else {		
		GetPrivateProfileString(lpszKey,lpszSubKey,"",tmp,INI_MAX_LEN,lpszFile);
		if(tmp[0]) {
			iData= atoi(tmp);
		} else {
			iData= iDefault;
		}
	}
}

// tOf[^(32bitl)
void IniIO_BOOL(BOOL bSaveFlg,char *lpszFile,char *lpszKey,char *lpszSubKey,BOOL& bFlag,BOOL iDefault)
{
	IniIO_INT(bSaveFlg,lpszFile,lpszKey,lpszSubKey,bFlag,iDefault);
}


// IvVt@C̃ANZX
// Init@Cւ̕ۑWin32ŐĂȂǃeLXgҏW₷֐̂(I/O͍ł͂Ȃ)
BOOL CCapUSB_Main::OptionIO(BOOL bSave)
{
	char *pKey;
	char cur_dir[MAX_PATH];
	BOOL bNoData=FALSE;
	
	// ǂݍ݃[hAf[^邩
	if(!bSave)
	{
		if(GetFileAttributes(m_szOptionFile)==INVALID_FILE_ATTRIBUTES) bNoData=TRUE;
	}	
	GetCurrentDirectory(MAX_PATH,cur_dir);

	// CapUSB Section
	pKey="CapUSB_M";

	IniIO_BOOL(bSave,m_szOptionFile,pKey,"HV_MIKITTY_INIT"		,m_stOpt.bHvMikittyInit,FALSE);
	IniIO_BOOL(bSave,m_szOptionFile,pKey,"ARIB_B25_PROC"		,m_stOpt.bARIB_B25,FALSE);
	IniIO_BOOL(bSave,m_szOptionFile,pKey,"REC_AUTOFILENAME"		,m_stOpt.bAutoFilename,FALSE);
	IniIO_String(bSave,m_szOptionFile,pKey,"REC_AUTOPATH"		,m_stOpt.szAutoPath,MAX_PATH,cur_dir);
	IniIO_INT(bSave,m_szOptionFile,pKey,"TIMER_PERIOD"			,m_stOpt.iTimerPeriod,1);
	IniIO_INT(bSave,m_szOptionFile,pKey,"THREAD_PRIORITY_REC"	,m_stOpt.iThreadPriorityReq,THREAD_PRIORITY_NORMAL);
	IniIO_INT(bSave,m_szOptionFile,pKey,"THREAD_PRIORITY_RES"	,m_stOpt.iThreadPriorityRes,THREAD_PRIORITY_NORMAL);
	IniIO_INT(bSave,m_szOptionFile,pKey,"THREAD_PRIORITY_PROC"	,m_stOpt.iThreadPriorityProc,THREAD_PRIORITY_NORMAL);

	IniIO_INT(bSave,m_szOptionFile,pKey,"LAST_EP_IN"			,m_stOpt.iLastInEP,0x86);
	IniIO_INT(bSave,m_szOptionFile,pKey,"LAST_EP_OUT"			,m_stOpt.iLastOutEP,0x01);

	IniIO_INT(bSave,m_szOptionFile,pKey,"REC_TIME"				,m_stOpt.iRecTime,0);

	IniIO_String(bSave,m_szOptionFile,pKey,"NETWORK_ADDRESS"	,m_stOpt.szNetworkAddress,MAX_PATH,"localhost");
	IniIO_INT(bSave,m_szOptionFile,pKey,"NETWORK_PORT"			,m_stOpt.iNetworkPort,1234);	// 1234VLCftHgUDP|[g
	IniIO_INT(bSave,m_szOptionFile,pKey,"NETWORK_SEND_SIZE"		,m_stOpt.iNetworkSendSize,32767);// 65535-UDPwb_TCY-ʑwTCYȂ̂ŁA60000xx

	IniIO_INT(bSave,m_szOptionFile,pKey,"POS_X"			,m_stOpt.iPosX,-30000);
	IniIO_INT(bSave,m_szOptionFile,pKey,"POS_Y"			,m_stOpt.iPosY,-30000);

	IniIO_BOOL(bSave,m_szOptionFile,pKey,"CHWND_SHOW"	,m_stOpt.bShowChWnd,FALSE);
	IniIO_INT(bSave,m_szOptionFile,pKey,"CHWND_POS_X"	,m_stOpt.iChPosX,-30000);
	IniIO_INT(bSave,m_szOptionFile,pKey,"CHWND_POS_Y"	,m_stOpt.iChPosY,-30000);
	IniIO_INT(bSave,m_szOptionFile,pKey,"LAST_CHANNEL"	,m_stOpt.iLastSelCh,-1);
	IniIO_INT(bSave,m_szOptionFile,pKey,"REMOTE_CONTROLLER_CODE"	,m_stOpt.iRemoteControllerCode,1);

	IniIO_BOOL(bSave,m_szOptionFile,pKey,"FILTWND_SHOW"	,m_stOpt.bShowFiltWnd,FALSE);
	IniIO_INT(bSave,m_szOptionFile,pKey,"FILTWND_POS_X"	,m_stOpt.iFiltPosX,-30000);
	IniIO_INT(bSave,m_szOptionFile,pKey,"FILTWND_POS_Y"	,m_stOpt.iFiltPosY,-30000);
	IniIO_INT(bSave,m_szOptionFile,pKey,"FILTWND_SIZE_X",m_stOpt.iFiltSizeX,0);
	IniIO_INT(bSave,m_szOptionFile,pKey,"FILTWND_SIZE_Y",m_stOpt.iFiltSizeY,0);

	IniIO_BOOL(bSave,m_szOptionFile,pKey,"SCHEDULE_SHOW",m_stOpt.bShowScheduleWnd,FALSE);
	IniIO_INT(bSave,m_szOptionFile,pKey,"SCHEDULE_POS_X",m_stOpt.iSchePosX,-30000);
	IniIO_INT(bSave,m_szOptionFile,pKey,"SCHEDULE_POS_Y",m_stOpt.iSchePosY,-30000);
	IniIO_INT(bSave,m_szOptionFile,pKey,"SCHEDULE_SIZE_X",m_stOpt.iScheSizeX,0);
	IniIO_INT(bSave,m_szOptionFile,pKey,"SCHEDULE_SIZE_Y",m_stOpt.iScheSizeY,0);

	IniIO_BOOL(bSave,m_szOptionFile,pKey,"NO_REJECT_NULLPACKET"	,m_stOpt.bNoRejectNullPacket,FALSE);

	pKey="CapUSB_M_PSI";
	IniIO_BOOL(bSave,m_szOptionFile,pKey,"DECODE_PSI"	,m_stOpt.bDecodePSI,FALSE);
	IniIO_BOOL(bSave,m_szOptionFile,pKey,"PROC_EPG"		,m_stOpt.bProcEPG,FALSE);
	IniIO_BOOL(bSave,m_szOptionFile,pKey,"PROC_DATA"	,m_stOpt.bProcData,FALSE);

	pKey="CapUSB_M_SCHEDULE";
	IniIO_BOOL(bSave,m_szOptionFile,pKey,"SCHEDULE_USE_SYSTEM_TIME"	,m_stOpt.bUseSystemTime,FALSE);

	return TRUE;
}

BOOL CCapUSB_Main::OnOptionDlg()
{
	if(m_bDeviceConnect)
	{
		MessageBox(m_hWnd,"ڑ͐ݒύXł܂","capusb",MB_OK);
		return FALSE;
	} else {
		return IDOK==DialogBoxParam(m_hInst,MAKEINTRESOURCE(IDD_OPTION),m_hWnd,(DLGPROC)CapUSB_OptionDlg,(LPARAM)this);
	}
}

LRESULT CALLBACK CCapUSB_Main::CapUSB_OptionDlg(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
#pragma warning(disable: 4312)
	CCapUSB_Main* pThis=(CCapUSB_Main*)GetWindowLongPtr(hDlg,GWL_USERDATA);
#pragma warning(default: 4312)

	switch (message)
	{
	case WM_INITDIALOG:
		{
			pThis=(CCapUSB_Main*)lParam;
#pragma warning(disable: 4311)
			SetWindowLongPtr(hDlg,GWL_USERDATA,(LONG)pThis);
#pragma warning(default: 4311)
			return pThis->OnOptionInitDialog(hDlg);
		}
		break;
	case WM_COMMAND:
		return pThis->OnOptionCommand(hDlg,wParam,lParam);
		break;
	}
	return FALSE;
}

BOOL CCapUSB_Main::OnOptionInitDialog(HWND hDlg)
{
	LRESULT i,n,val;
	char buf[80];

	SetDlgItemInt(hDlg,IDC_TIMER,m_stOpt.iTimerPeriod,TRUE);

	wsprintf(buf,"W^C}\ : %.2lf ms",m_dTimerClock);
	SetDlgItemText(hDlg,IDC_SYSTEM_TIMER,buf);

	wsprintf(buf,"ݒ\͈ : %d - %d",m_stTimeCaps.wPeriodMin,m_stTimeCaps.wPeriodMax);
	SetDlgItemText(hDlg,IDC_TIMER_RANGE,buf);

	CheckDlgButton(hDlg,IDC_AUTOFILENAME,m_stOpt.bAutoFilename?BST_CHECKED:BST_UNCHECKED);
	SetDlgItemText(hDlg,IDC_AUTOFILEPATH,m_stOpt.szAutoPath);

	// Thread
	val=SendDlgItemMessage(hDlg,IDC_THREAD_REQ	,CB_ADDSTRING,0,(LPARAM)"W");
	val=SendDlgItemMessage(hDlg,IDC_THREAD_REQ	,CB_SETITEMDATA,val,THREAD_PRIORITY_NORMAL);
	val=SendDlgItemMessage(hDlg,IDC_THREAD_REQ	,CB_ADDSTRING,0,(LPARAM)"ʏȏ");
	val=SendDlgItemMessage(hDlg,IDC_THREAD_REQ	,CB_SETITEMDATA,val,THREAD_PRIORITY_ABOVE_NORMAL);
	val=SendDlgItemMessage(hDlg,IDC_THREAD_REQ	,CB_ADDSTRING,0,(LPARAM)"");
	val=SendDlgItemMessage(hDlg,IDC_THREAD_REQ	,CB_SETITEMDATA,val,THREAD_PRIORITY_HIGHEST);
	val=SendDlgItemMessage(hDlg,IDC_THREAD_REQ	,CB_SETCURSEL,0,0);
	n=SendDlgItemMessage(hDlg,IDC_THREAD_REQ	,CB_GETCOUNT,0,0);
	for(i=0;i<n;i++)
	{
		val=SendDlgItemMessage(hDlg,IDC_THREAD_REQ	,CB_GETITEMDATA,i,0);
		if(val==m_stOpt.iThreadPriorityReq)
		{
			val=SendDlgItemMessage(hDlg,IDC_THREAD_REQ	,CB_SETCURSEL,i,0);
			break;
		}
	}
	val=SendDlgItemMessage(hDlg,IDC_THREAD_RES	,CB_ADDSTRING,0,(LPARAM)"W");
	val=SendDlgItemMessage(hDlg,IDC_THREAD_RES	,CB_SETITEMDATA,val,THREAD_PRIORITY_NORMAL);
	val=SendDlgItemMessage(hDlg,IDC_THREAD_RES	,CB_ADDSTRING,0,(LPARAM)"ʏȏ");
	val=SendDlgItemMessage(hDlg,IDC_THREAD_RES	,CB_SETITEMDATA,val,THREAD_PRIORITY_ABOVE_NORMAL);
	val=SendDlgItemMessage(hDlg,IDC_THREAD_RES	,CB_ADDSTRING,0,(LPARAM)"");
	val=SendDlgItemMessage(hDlg,IDC_THREAD_RES	,CB_SETITEMDATA,val,THREAD_PRIORITY_HIGHEST);
	val=SendDlgItemMessage(hDlg,IDC_THREAD_RES	,CB_SETCURSEL,0,0);
	n=SendDlgItemMessage(hDlg,IDC_THREAD_RES	,CB_GETCOUNT,0,0);
	for(i=0;i<n;i++)
	{
		val=SendDlgItemMessage(hDlg,IDC_THREAD_RES	,CB_GETITEMDATA,i,0);
		if(val==m_stOpt.iThreadPriorityRes)
		{
			val=SendDlgItemMessage(hDlg,IDC_THREAD_RES	,CB_SETCURSEL,i,0);
			break;
		}
	}
	val=SendDlgItemMessage(hDlg,IDC_THREAD_PROC	,CB_ADDSTRING,0,(LPARAM)"W");
	val=SendDlgItemMessage(hDlg,IDC_THREAD_PROC	,CB_SETITEMDATA,val,THREAD_PRIORITY_NORMAL);
	val=SendDlgItemMessage(hDlg,IDC_THREAD_PROC	,CB_ADDSTRING,0,(LPARAM)"ʏȏ");
	val=SendDlgItemMessage(hDlg,IDC_THREAD_PROC	,CB_SETITEMDATA,val,THREAD_PRIORITY_ABOVE_NORMAL);
	val=SendDlgItemMessage(hDlg,IDC_THREAD_PROC	,CB_ADDSTRING,0,(LPARAM)"");
	val=SendDlgItemMessage(hDlg,IDC_THREAD_PROC	,CB_SETITEMDATA,val,THREAD_PRIORITY_HIGHEST);
	val=SendDlgItemMessage(hDlg,IDC_THREAD_PROC	,CB_SETCURSEL,0,0);
	n=SendDlgItemMessage(hDlg,IDC_THREAD_PROC	,CB_GETCOUNT,0,0);
	for(i=0;i<n;i++)
	{
		val=SendDlgItemMessage(hDlg,IDC_THREAD_PROC	,CB_GETITEMDATA,i,0);
		if(val==m_stOpt.iThreadPriorityProc)
		{
			val=SendDlgItemMessage(hDlg,IDC_THREAD_PROC	,CB_SETCURSEL,i,0);
			break;
		}
	}

	CheckDlgButton(hDlg,IDC_EPG,m_stOpt.bProcEPG?BST_CHECKED:BST_UNCHECKED);
	CheckDlgButton(hDlg,IDC_DATA,m_stOpt.bProcData?BST_CHECKED:BST_UNCHECKED);
	CheckDlgButton(hDlg,IDC_PSI,m_stOpt.bDecodePSI?BST_CHECKED:BST_UNCHECKED);	

	CheckDlgButton(hDlg,IDC_SCHEDULE_SYSTEM_TIME,m_stOpt.bUseSystemTime?BST_CHECKED:BST_UNCHECKED);

	CDTV_OptCUsb2 *pOptCapUSB2 = dynamic_cast<CDTV_OptCUsb2*>(this->m_pDTV);
	if(pOptCapUSB2)
	{
		ShowWindow(GetDlgItem(hDlg,IDC_REMOTE_CONTROLLER_CODE),SW_SHOW);
		ShowWindow(GetDlgItem(hDlg,IDC_STATIC_REMOTE_CONTROLLER_CODE),SW_SHOW);

		for (i = 1; i <= 3; i++) {
			wsprintf(buf, "%d", i);
			val = SendDlgItemMessage(hDlg, IDC_REMOTE_CONTROLLER_CODE, CB_ADDSTRING, 0, (LPARAM)buf);
			SendDlgItemMessage(hDlg, IDC_REMOTE_CONTROLLER_CODE, CB_SETITEMDATA, (WPARAM)val, (LPARAM)i);
		}
		for (i = 0; i < 3; i++) {
			val = SendDlgItemMessage(hDlg, IDC_REMOTE_CONTROLLER_CODE, CB_GETITEMDATA, (WPARAM)i, (LPARAM)0);
			if (val == m_stOpt.iRemoteControllerCode) {
				SendDlgItemMessage(hDlg, IDC_REMOTE_CONTROLLER_CODE, CB_SETCURSEL, (WPARAM)i, (LPARAM)0);
				break;
			}
		}
	}

	return TRUE;
}

BOOL CCapUSB_Main::GetOptionFromDlg(HWND hDlg,struct CapUSB_Option &stOpt)
{
	LRESULT val;
	BOOL bSuccess;
	stOpt.iTimerPeriod=GetDlgItemInt(hDlg,IDC_TIMER,&bSuccess,FALSE);
	if(!bSuccess||stOpt.iTimerPeriod!=0)
	{
		if(!bSuccess||(unsigned)stOpt.iTimerPeriod<m_stTimeCaps.wPeriodMin||(unsigned)m_stOpt.iTimerPeriod>m_stTimeCaps.wPeriodMax)
		{
			MessageBox(hDlg,"^C}xݒlsł","capusb",MB_OK);
			return FALSE;
		}
	}

	stOpt.bAutoFilename=(IsDlgButtonChecked(hDlg,IDC_AUTOFILENAME)==BST_CHECKED?TRUE:FALSE);
	GetDlgItemText(hDlg,IDC_AUTOFILEPATH,stOpt.szAutoPath,MAX_PATH);
	if(GetFileAttributes(stOpt.szAutoPath)==INVALID_FILE_ATTRIBUTES)
	{
		MessageBox(hDlg,"ۑpX͖ł","capusb",MB_OK);
		return FALSE;
	}

	// ڑIȂTHREAD_PRIORITY_NORMAL=0ɂȂĂƊ
	val=SendDlgItemMessage(hDlg,IDC_THREAD_REQ	,CB_GETCURSEL,0,0);
	val=SendDlgItemMessage(hDlg,IDC_THREAD_REQ	,CB_GETITEMDATA,val,0);
	stOpt.iThreadPriorityReq=(int)(val&0xffffffff);
	val=SendDlgItemMessage(hDlg,IDC_THREAD_RES	,CB_GETCURSEL,0,0);
	val=SendDlgItemMessage(hDlg,IDC_THREAD_RES	,CB_GETITEMDATA,val,0);
	stOpt.iThreadPriorityRes=(int)(val&0xffffffff);
	val=SendDlgItemMessage(hDlg,IDC_THREAD_PROC	,CB_GETCURSEL,0,0);
	val=SendDlgItemMessage(hDlg,IDC_THREAD_PROC	,CB_GETITEMDATA,val,0);
	stOpt.iThreadPriorityProc=(int)(val&0xffffffff);

	stOpt.bProcEPG=(IsDlgButtonChecked(hDlg,IDC_EPG)==BST_CHECKED?TRUE:FALSE);
	stOpt.bProcData=(IsDlgButtonChecked(hDlg,IDC_DATA)==BST_CHECKED?TRUE:FALSE);
	stOpt.bDecodePSI=(IsDlgButtonChecked(hDlg,IDC_PSI)==BST_CHECKED?TRUE:FALSE);

	stOpt.bUseSystemTime=(IsDlgButtonChecked(hDlg,IDC_SCHEDULE_SYSTEM_TIME)==BST_CHECKED?TRUE:FALSE);

	val = SendDlgItemMessage(hDlg, IDC_REMOTE_CONTROLLER_CODE, CB_GETCURSEL, (WPARAM)0, (LPARAM)0);
	stOpt.iRemoteControllerCode = SendDlgItemMessage(hDlg, IDC_REMOTE_CONTROLLER_CODE, CB_GETITEMDATA, (WPARAM)val, (LPARAM)0);

	return TRUE;
}

BOOL CCapUSB_Main::OnOptionCommand(HWND hDlg,WPARAM wParam,LPARAM lParam)
{
	switch(LOWORD(wParam))
	{
	case IDOK:
		{
			struct CapUSB_Option stTmp;
			stTmp=m_stOpt;
			if(GetOptionFromDlg(hDlg,stTmp))
			{
				m_stOpt=stTmp;
				EndDialog(hDlg,IDOK);
			}			
		}
		break;
	case IDCANCEL:
		{
			EndDialog(hDlg,IDCANCEL);
		}
		break;
	}
	return TRUE;
}